#include<bits/stdc++.h>
using namespace std;

int main(){
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    int m, x, y, tx, ty, ttx, tty, px, py, t;
    vector <pair <int, int>> v;
    vector <int> vx, vy;
    cin >> m;
    for (int i = 0; i < m; i++){
        cin >> x >> y;
        v.push_back(make_pair(x, y));
    }
    cout << 0 << "\n";
    for (int i = 1; i < m; i++){
        t = 0;
        tx = 0;
        ty = 0;
        for (int j = 0; j <= i; j++){
            ttx = 0;
            for (int k = 0; k <= i; k++){
                ttx += abs(v[j].first - v[k].first);
            }
            if (ttx > tx){
                tx = ttx;
                px = j;
            }
        }
        for (int j = 0; j <= i; j++){
            tty = 0;
            for (int k = 0; k <= i; k++){
                tty += abs(v[j].second - v[k].second);
            }
            if (tty > ty){
                ty = tty;
                py = j;
            }
        }
        for (int j = 0; j <= i; j++){
            t += abs(v[j].first  - v[px].first) * abs(v[j].second  - v[py].second);
        }
        cout << t << "\n";
    }
    return 0;
}